import java.sql.*; 
import java.util.*;
public final class ConnectionPool{ 
	static{ 
		try{ 
			Class.forName("oracle.jdbc.driver.OracleDriver"); 
		}catch(ClassNotFoundException cnfe){ 
			cnfe.printStackTrace(); 
		} 
	} 
	//   Ŀؼ , ʱ Ŀؼ ϴ  
	private ArrayList<Connection> free; 

	//   Ŀؼ ϴ  
	private ArrayList<Connection> used; 

	private String url; 
	private String user; 
	private String password; 

	// ʱ ĿؼǼ 
	private int initialCons = 0; 

	// ִ ĿؼǼ 
	private int maxCons = 0; 

	//  ĿؼǼ 
	private int numCons = 0; 
	private static ConnectionPool cp; 

	public static ConnectionPool getInstance(String url, 
			String user, String password, 
			int initialCons, int maxCons){ 
		try{ 
			if(cp == null){ 
				synchronized(ConnectionPool.class){ 
					cp=new ConnectionPool(url,user,

							password,initialCons,maxCons) ; 

				} 
			} 
		} 
		catch(SQLException sqle){ 
			sqle.printStackTrace(); 
		} 
		return cp; 
	} 

	private ConnectionPool(String url, String user, 
			String password, int initialCons, int maxCons) 
					throws SQLException{ 

		this.url = url; 
		this.user = user; 
		this.password = password; 
		this.initialCons = initialCons; 
		this.maxCons = maxCons; 

		if (initialCons < 0) 
			initialCons = 5; 
		if(maxCons < 0) 
			maxCons = 10; 

		/* 
 ʱ Ŀؼ   ArrayList   
 ֵ ʱ Ŀؼ ŭ ArrayList Ѵ. 
		 */ 
		free = new ArrayList<Connection>(initialCons); 
		used = new ArrayList<Connection>(initialCons); 

		// initialCons ŭ Connection (free)Ѵ. 
		while (numCons < initialCons){

			addConnection(); 
		} 
	} 
	// free Ŀؼ ü Ѵ. 
	private void addConnection() throws SQLException{ 
		free.add(getNewConnection()); 
	} 

	// ο Ŀؼ ü Ѵ. 
	private Connection getNewConnection() 
			throws SQLException{ 
		Connection con = null; 
		try{ 
			con = DriverManager.getConnection(url, 
					user, password); 
		}catch (SQLException e){ 
			e.printStackTrace(); 
		} 
		System.out.println("About to connect to " + con); 
		//ؼ   ڰ Ѵ. 
		++numCons; 
		return con; 
	} 

	/* 
 free ִ Ŀؼ used 
 ű ۾ => free--->used 
	 */ 
	public synchronized Connection getConnection() 
			throws SQLException{ 
		/* 
 free Connection  
 maxConsŭ Connection  Ѵ. 
		 */ 
		if(free.isEmpty()){

			while(numCons < maxCons){ 
				addConnection(); 
			} 
		} 
		Connection _con; 
		_con = free.get(free.size()-1); 
		free.remove(_con); 
		used.add(_con); 
		return _con; 
	} 
	/* 
 used ִ Ŀؼ 
 free ݳѴ. 
	 */ 
	public synchronized void releaseConnection( 
			Connection _con) 
					throws SQLException { 
		boolean flag = false; 
		if (used.contains(_con)){ 
			used.remove(_con); 
			numCons--; 
			flag = true; 
		}else{ 
			throw new SQLException("ConnectionPool" 
					+" ʳ׿!!"); 
		} 
		try{ 
			if (flag){ 
				free.add(_con); 
				numCons++; 
			}else{ 
				_con.close(); 
			} 

		}catch (SQLException e){

			try{ 
				_con.close(); 
			}catch(SQLException e2){ 
				e2.printStackTrace(); 
			} 
		} 
	} 
	//  Connection ڿ ݳѴ. 
	public void closeAll(){ 
		// used ִ Ŀؼ  Ѵ. 
		for(int i=0;i<used.size();i++){ 
			Connection _con = (Connection)used.get(i); 
			used.remove(i--); 
			try{ 
				_con.close(); 
			}catch(SQLException sqle){ 
				sqle.printStackTrace(); 
			} 
		} 

		// free ִ Ŀؼ  Ѵ. 
		for(int i=0;i<free.size();i++){ 
			Connection _con = (Connection)free.get(i); 
			free.remove(i--); 
			try{ 
				_con.close(); 
			}catch(SQLException sqle){ 
				sqle.printStackTrace(); 
			} 
		} 
	} 
	public int getMaxCons(){ 
		return maxCons; 
	} 
	public int getNumCons(){

		return numCons; 
	} 
}